'ebnaut_ifft1.bas by df6nm
deflng a-z

fname$="08161726"
cmd$ = ltrim$(rtrim$(command$))
if len(cmd$)>=8 then fname$=left$(cmd$,8) 

ffttxtfile$=fname$+".txt"
fftbinfile$="fft.dat"
iqfile$=fname$+".wav"

df!=5513.0493!/24/(2^18)/2

OPEN ffttxtfile$ FOR INPUT AS 1

INPUT #1, filedate&, filetime&, bw!, startfreq!
filetime$ = RIGHT$("00000" + LTRIM$(STR$(filetime&)), 6)
filemidhours! = VAL(LEFT$(filetime$, 2)) + VAL(MID$(filetime$, 3, 2)) / 60 + VAL(RIGHT$(filetime$, 2)) / 3600
filestarthours! = filemidhours! - .5 / df! / 3600!
fileendhours! = filemidhours! + .5 / df! / 3600!

filedate$ = RIGHT$("00000000" + LTRIM$(STR$(filedate&)), 8)
filedate$ = LEFT$(filedate$, 4) + "-" + MID$(filedate$, 5, 2) + "-" + RIGHT$(filedate$, 2)
PRINT filedate$; " ";filetime&;filestarthours!;fileendhours!

 OPEN fftbinfile$ FOR OUTPUT AS 2
 WHILE NOT EOF(1)
  INPUT #1, ar!, ai!
  PRINT #2, MKS$(ar!); MKS$(ai!);
 WEND
 CLOSE 2
CLOSE 1

'end

OPEN fftbinfile$ FOR BINARY AS 1
nm& = LOF(1) / 8
bytesleft& = nm& * 8
SEEK #1, 1
nbufm = 1024: buf$ = SPACE$(nbufm)
nbufptr = nbufm

 lmx = 18: nmx = 2^lmx
 nmx1 = nmx - 1: nm21x = 2 * nmx - 1
 DIM ax!(nm21x), wx!(nmx1), nbrx&(nmx1)
 GOSUB calcwx
 GOSUB calcbitrevx

 'SEEK #1, 8 * (npeakfft& - nmx \ 2) + 1
 a$ = INPUT$(8 * nmx, #1)
 FOR n = 0 TO nm21x
  ax!(n) = CVS(MID$(a$, 4 * n + 1, 4))   'centered on nmx/2
 NEXT n

 FOR n = 0 TO nmx-1
  SWAP ax!(n), ax!(n+nmx) '0 Hz to bin 0
 NEXT n

 FOR n = 1 to nm21x-1 step 2
  ax!(n)=-ax!(n) 'conj complex for inv fft
 NEXT n
 GOSUB fftbasx   'IFFT
 FOR n = 1 to nm21x-1 step 2
  ax!(n)=-ax!(n) 'conj complex
 NEXT n

 OPEN iqfile$ FOR OUTPUT AS 2
 GOSUB wavheader
 ? #2,hdr$;
 FOR n = 0 TO nm21x
  PRINT #2, mks$(ax!(n));
 NEXT n
 CLOSE 2

 OPEN "out.txt" FOR OUTPUT AS 2
 FOR n = 0 TO nm21x step 2
  PRINT #2, ax!(n);" "; ax!(n+1);
 NEXT n
 CLOSE 2

end

'_______________________________________
 wavheader:
 sr!=df!*nmx

 inf1$="sr="+ltrim$(str$(sr!))+" "
 inf1$=inf1$+"rf=137499.982 "
 inf1$=inf1$+"ut=1422202799.44 "
 inf1$=inf1$+mkl$(0)
 inf1$=left$(inf1$,4*int((len(inf1$)-1)\4)) 
 inf1$="inf1"+mkl$(len(inf1$))+inf1$
 ? inf1$;"*"
 
 fmt$=mki$(-2)+mki$(2)+mkl$(sr!)+mkl$(248)
 fmt$=fmt$+mki$(8)+mki$(32)+mki$(22)+mki$(32)+mkl$(0)+mkl$(3)
 fmt$=fmt$+mki$(0)+mki$(16)+mki$(128)+mki$(-22016)+mki$(14336)+mki$(29083)
 fmt$="fmt "+mkl$(len(fmt$))+fmt$

 fact$="fact"+mkl$(4)+mkl$(18151)

 hdr$="RIFF"+mkl$(len(inf1$)+8*nmx)
 hdr$=hdr$+"WAVE"+fmt$+fact$+inf1$+"data"+mkl$(8*nmx)
 ? hdr$;"*"
return


'_______________________________________
'FFT stuff

calcwx:
'nmx/2 warp factors
  sc! = 1
  pi! = 4 * ATN(1)
  FOR n = 0 TO nmx \ 2 - 1
   wx!(2 * n) = sc! * COS(2 * pi! * n / nmx)
   wx!(2 * n + 1) = sc! * -SIN(2 * pi! * n / nmx)
  NEXT n
 RETURN

calcbitrevx:
'bit reversal table
  FOR n = 0 TO nmx - 1
   n2 = 0: n1 = n
   FOR l = 0 TO lmx - 1
    n2 = 2 * n2 + (n1 AND 1)
    n1 = n1 \ 2
   NEXT l
   nbrx&(n) = n2
  NEXT n
 RETURN

'original basic fft

fftbasx:
 FOR n = 0 TO nmx - 1
  n2 = nbrx&(n)
  IF n2 < n THEN SWAP ax!(2 * n), ax!(2 * n2): SWAP ax!(2 * n + 1), ax!(2 * n2 + 1)
 NEXT n

 nd = 1: nwd = nmx \ 2
 FOR l = 0 TO lmx - 1
  FOR n0 = 0 TO nmx - 1 STEP 2 * nd
   nw = 0
   FOR n1 = n0 TO n0 + nd - 1
    n2 = n1 + nd
   
    n1r = 2 * n1: n1i = n1r + 1
    n2r = 2 * n2: n2i = n2r + 1
    nwr = 2 * nw: nwi = nwr + 1

    vr! = (ax!(n2r) * wx!(nwr) - ax!(n2i) * wx!(nwi))
    vi! = (ax!(n2i) * wx!(nwr) + ax!(n2r) * wx!(nwi))
    ax!(n2r) = ax!(n1r) - vr!: ax!(n2i) = ax!(n1i) - vi!
    ax!(n1r) = ax!(n1r) + vr!: ax!(n1i) = ax!(n1i) + vi!
    nw = nw + nwd
   NEXT n1
  NEXT n0
  nd = 2 * nd
  nwd = nwd \ 2
 NEXT l
RETURN

'________________________________
invffttest:
 PRINT
 FOR n = 0 TO 12
  ax!(2 * n) = 1
  ax!(2 * n + 1) = n
 NEXT n
 GOSUB outax
 GOSUB fftbasx
 GOSUB outax
 'either conjugate
 FOR n = 0 TO nmx1
  ax!(2 * n + 1) = -ax!(2 * n + 1)
 NEXT n
 GOSUB fftbasx
 'divide by 16
 FOR n = 0 TO nm21x
  ax!(n) = ax!(n) / nmx
 NEXT n
 'and conjugate again
 FOR n = 0 TO nmx1
  ax!(2 * n + 1) = -ax!(2 * n + 1)
 NEXT n
 'or swap  1<->15, 2<->14 ...
 FOR n = 1 TO nmx / 2
  'SWAP ax!(2 * n), ax!(2 * nmx - 2 * n)
  'SWAP ax!(2 * n + 1), ax!(2 * nmx - 2 * n + 1)
 NEXT n
 GOSUB outax
END
outax:
 FOR n = 0 TO nmx1
  PRINT USING "##.# "; ax!(2 * n);
 NEXT n
 PRINT
 FOR n = 0 TO nmx1
  PRINT USING "##.# "; ax!(2 * n + 1);
 NEXT n
 PRINT
 PRINT
RETURN
'_________________________________
